//class MyThread extends Threads...
//funktioniert hier nicht einwandfrei:
//Es kommt zu unvorhersehbaren Pixelfehlern
class MyThread extends Thread {
  
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public MyThread(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh) {
    // benötigte Parameter
   
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    pg = createGraphics(width,height/anzahlThreads);
   
  }

 //////////////////////////////////////////////////////////////
  
  public void run() {
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        println("y: "+ymin,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j = 0; j < pg.height; j++) {
          double x = xmin;
          for (int i = 0; i < pg.width; i++) {
            int n = mandelbrotIteration(x, y);
            pg.pixels[i+j*pg.width] = colorize(n);
            if (((x<=0) && (x+dx>0)) || ((y<=0) && (y+dy>0)))
              pg.pixels[i+j*pg.width] = color(0,0,50); //Koordinatenachsen
            x += dx;
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  
/////////////////////////////////////////////////////////////////////
int mandelbrotIteration(double x, double y) {

  // nun wird für eine komplexe Zahl bzw. einen Punkt der Ebene getestet, 
  // wohin er bei der Iteration geht. Je nachdem wird er dann später ein-
  // gefärbt
  double a = x;
  double b = y;
  int n = 0;
  while (n < maxiterations) {
    double aa = a * a;
    double bb = b * b;
    double twoab = 2.0 * a * b;
    a = aa - bb  + x;
    b = twoab + y;
    
    if (aa + bb > massFuerUnendlich) {
      break;  // Bail
    }
    n++;
  }
  return n;
 }
/////////////////////////////////////////////////////////////
color colorize(int n) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
  // bis entweder der Wert der komplexen Zahl Null oder über einer
  // Schwelle ist
  if (n == maxiterations){
    return color(0, 0, 0);
  }else{
   color col = color(255*n/maxiterations,255,255);
    return col; 
  }
 }
}